const perform = require("nio-http-request");
const NioProxy = require("nio-proxy");
const NioProxyRequest = function(url,filter) {
	this.proxies = new NioProxy(url,filter);
	return this;
};
NioProxyRequest.prototype.perform = async function(url,options,filter) {
	options = options || {};
	var proxy = await this.proxies.call(filter);
	if (!proxy.error) options.proxy = proxy.proxy;
	var resp = await perform(url,options);
	if (!proxy.error) {
		if (resp.err) 
		 	 await proxy.errors();
		else await proxy.success();
	}
	resp.proxy = (!proxy.error) ? proxy.proxy : "NO_PROXY";
	return resp;
};
module.exports = NioProxyRequest;